#!/bin/sh
. ../../config.txt
filename=$QUERY_STRING
filename=`basename $filename`
if [ -z $file ] || [ -z $filename ] || [ ! -e $file/$filename ];then
	echo -e "Content-Type: text/plain\n"
	echo "Invalid request."
	exit
fi
filesize=`ls -l $file/$filename|awk '{print $5}'`
echo "Content-Type: application/octet-stream"
echo "Content-Disposition: attachment; filename=\"$filename\""
echo -e "Content-Length: $filesize\n"
dd if="$file/$filename"
