FILE.update=function(table){
	var div=document.createElement('div');
	var sel=document.createElement('input');
	var menu=document.createElement('menu');
	div.className='filelist';
	div.setAttribute('contextmenu','contextmenu');
	menu.id='contextmenu';
	menu.type='context';
	div.appendChild(menu);
	div.addEventListener('contextmenu',function(e){
		let menu=document.getElementById('contextmenu');
		while(menu.firstChild){
			menu.removeChild(menu.firstChild);
		}
		let menuitem=document.createElement('menuitem');
		menuitem.label='Upload';
		menuitem.addEventListener('click',function(){document.getElementById('fileselect').click()},false);
		menu.appendChild(menuitem);
		if(e.target.className=='filename'){
			let file=e.target.textContent;
			menuitem=document.createElement('menuitem');
			menuitem.label='Delete';
			menuitem.addEventListener('click',function(){FILE.delete(file)},false);
			menu.appendChild(menuitem);
		}
	},false);
	sel.id='fileselect';
	sel.type='file';
	sel.style.display='none';
	sel.addEventListener('change',function(e){FILE.select(e)},false);
	div.appendChild(sel);
	div.appendChild(table);
	div.addEventListener('dragover',function(e){e.dataTransfer.dropEffect='copy'},false);
	div.addEventListener('drop',function(e){FILE.drop(e)},false);
	MAIN.update(div);
};
FILE.table=function(arg){
	var obj=[];
	obj[1]=['Name','Last modified','Size'];
	obj[2]=[];
	for(let i=0;i<arg.length;i++){
		var a=document.createElement('a');
		a.appendChild(document.createTextNode(arg[i][0]));
		a.href=PATH['file/get.cgi']+'?'+arg[i][0];
		a.className='filename';
		obj[2].push([a,arg[i][1],arg[i][2]]);
	}
	FILE.update(MAIN.table(obj));
};
FILE.drop=function(e){
	if(!e.dataTransfer.files || !e.dataTransfer.files[0]) return;
	FILE.upload(e.dataTransfer.files[0]);
};
FILE.select=function(e){
	if(!e.target.files || !e.target.files[0]) return;
	FILE.upload(e.target.files[0]);
};
FILE.delete=function(file){
	MAIN.xhr(PATH['file/delete.cgi']+'?'+file,'',FILE.init);
};
FILE.upload=function(file){
	fd=new FormData();
	fd.append("file",file);
	MAIN.xhr(PATH['file/upload.cgi'],fd,FILE.init);
};
FILE.init=function(){
	MAIN.load(PATH['file/list.cgi']);
	MAIN.tabupdate('FILE');
};
FILE.init();
