var PATH=[];
PATH['init.cgi']='cgi-bin/init.cgi';
PATH['file/list.cgi']='cgi-bin/file/list.cgi';
PATH['file/upload.cgi']='cgi-bin/file/upload.cgi';
PATH['file/get.cgi']='cgi-bin/file/get.cgi';
PATH['file/delete.cgi']='cgi-bin/file/delete.cgi';
PATH['stat/run.cgi']='cgi-bin/stat/run.cgi';
PATH['log/tail.cgi']='cgi-bin/log/tail.cgi';
var MAIN=[];
var FILE=[];
var STAT=[];
var LOG=[];
FILE.js='file.js';
STAT.js='stat.js';
LOG.js='log.js';
MAIN.default=STAT;
MAIN.module=[];
MAIN.module.FILE=FILE;
MAIN.module.STAT=STAT;
MAIN.module.LOG=LOG;
MAIN.update=function(arg){
	var area=MAIN.clean('main');
	area.appendChild(arg);
	return(area);
}
MAIN.clean=function(arg){
	var area=document.getElementById(arg);
	while(area.firstChild){
	area.removeChild(area.firstChild);
	}
	return(area);
};
MAIN.table=function(arg){
	var table=document.createElement('table');
	if(arg[0]) table.className=arg[0];
	var tr=document.createElement('tr');
	for(var i=0;i<arg[1].length;i++){
		var th=document.createElement('th');
		th.appendChild(document.createTextNode(arg[1][i]));
		tr.appendChild(th);
	}
	table.appendChild(tr);
	for(let i=0;i<arg[2].length;i++){
		var tr=document.createElement('tr');
		for(let j=0;j<arg[2][i].length;j++){
			var td=document.createElement('td');
			if(arg[2][i][j].nodeType){
				td.appendChild(arg[2][i][j]);
			}else{
				td.appendChild(document.createTextNode(arg[2][i][j]));
			}
			tr.appendChild(td);
		}
		table.appendChild(tr);
	}
	return(table);
};
MAIN.load=function(arg){
	var src=arg;
	if(typeof arg == 'object'){
		if(arg.init) arg.init();
		if(arg.loaded) return;
		arg.loaded=1;
		src=arg.js;
	}
	var head=document.getElementsByTagName('head')[0];
	var loaded=head.getElementsByTagName('script');
	for(let i=0;i<loaded.length;i++){
		if(loaded[i].getAttribute('src')==src) head.removeChild(loaded[i]);
	}
	var script=document.createElement('script');
	script.src=src;
	head.appendChild(script);
};
MAIN.xhr=function(url,body,cb,mode){
	var http=new XMLHttpRequest();
	if(body){
		http.open("POST",url);
	}else{
		http.open("GET",url);
	}
	http.onreadystatechange=function(){
		if(http.readyState==4){
			if(mode){
				cb(http.responseText);
			}else{
				if(http.responseText){
					alert(http.responseText);
				}else{
					cb();
				}
			}
		}
	}
	http.send(body);
};
MAIN.tabupdate=function(id){
	if(document.getElementsByClassName('tab_active')[0]) document.getElementsByClassName('tab_active')[0].className='tab';
	var tabs=document.getElementById('tabgroup').getElementsByTagName('span');
	for(let i=0;i<tabs.length;i++){
		if(tabs[i].getAttribute('data-action')==id) tabs[i].className='tab_active';
	}
};
MAIN.init=function(arg){
	STAT.command=[];
	for(let i=0;i<arg.stat.length;i++){
		STAT.command[arg.stat[i][0]]=arg.stat[i][1];
	}
	LOG.file=[];
	for(let i=0;i<arg.log.length;i++){
		LOG.file[arg.log[i][0]]=arg.log[i][1];
	}
	document.getElementById('main').style.height="calc(100% - "+document.getElementById('tabgroup').clientHeight+"px)";
	var tabs=document.getElementsByClassName('tab');
	for(let i=0;i<tabs.length;i++){
		tabs[i].addEventListener('click',function(e){
			if(e.target.className=='tab_active') return;
			MAIN.load(MAIN.module[e.target.getAttribute('data-action')]);
		},false);
	}
	MAIN.load(MAIN.default);
};
window.addEventListener('load',function(){MAIN.load(PATH['init.cgi'])},false);
